namespace foo {

	// First class; it inherits from its only template argument
	template <class some_typedef>
	class inherits_from_typedef : public some_typedef {};

	// Second class; it inherits from the first class,
	// and assumes its template parameter has a member
	// called BAD_PARSE that is a type. It passes that
	// member as the argument to inherits_from_typedef,
	// and inherits from it.
	template <class class_with_typedef>
	class final : public inherits_from_typedef<typename class_with_typedef::BAD_PARSE> {};

} // namespace foo

// Just in case, for some reason, you wanted to make sure it'd compile :)
int main()
{
	return 0;
}
